package com.common.print;

import com.common.print.callback.PrintInitResultCallback;

/**
 * 打印基本接口
 */
public interface IPrinter {


    void initPrint(PrintInitResultCallback printInitResultCallback);

    /**
     * 打印文字
     * @param text
     * @param align
     * @param textSize
     * @param isBold
     */
    void printText(String text,int align,int textSize,boolean isBold);


    /**
     * 打印条形码
     * @param text
     */
    void printBarCode(String text,int width,int height);

    /**
     * 打印二维码
     */
    void printQrCode(String text,int width,int height);

    /**
     * 打印图片
     * @param base64
     */
    void printBitmap(String base64,int width,int height);

    /**
     * 走纸
     * 打印空行
     */
    void feed(int line);

    /**
     * 切纸
     */
    void cutPaper();

    /**
     * 打印机取消连接
     */
    void disconnect();

    /**
     * 开始打印
     */
    void startPrint();


}
